﻿using System;

namespace net.praqma.troja.library
{
    public class IllegalCommandException : Exception
    {
        private int authCode;

        public IllegalCommandException(int authCode)
            : base(GenerateMessage(authCode))
        {
            this.authCode = authCode;
        }

        public int AuthorizationCode
        {
            get { return authCode; }
        }

        private static string GenerateMessage(int code)
        {
            string message = "";

            if (code == 0)
            {
                return "OK.";
            }

            if ((code >> Filter.FILTERERROR) % 2 == 1)
            {
                message += "Filter error! ";
            }

            if ((code >> Filter.DENIEDUSER) % 2 == 1)
            {
                message += "Invalid user! ";
            }

            if ((code >> Filter.DENIEDCOMMAND) % 2 == 1)
            {
                message += "Invalid command or argument! ";
            }

            if ((code >> Filter.DENIEDENVIRONMENT) % 2 == 1)
            {
                message += "Illegal environment variable! ";
            }

            if ((code >> Filter.UNKNOWNCOMMAND) % 2 == 1)
            {
                message += "Unknown command! ";
            }

            if ((code >> Filter.UNALLOWEDARGUMENT) % 2 == 1)
            {
                message += "Unauthorized argument for the given command! ";
            }

            if ((code >> Filter.UNALLOWEDENVIRONMENT) % 2 == 1)
            {
                message += "Unauthorized environment variable for the given command! ";
            }

            if ((code >> Filter.UNALLOWEDUSER) % 2 == 1)
            {
                message += "Unauthorized user for the given command! ";
            }

            return message.Trim();
        }
    }
}
