using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Security.Principal;

namespace ScriptGUI
{
    public partial class ObsoluteStreams : System.Web.UI.Page
    {
        private static readonly string CMDID = "troja_obsolute_streams";
        private static TrojaWS proxy;
        private static string command = @"C:\Program Files\Rational\Common\ratlperl.exe";
        private static string arguments = @"\\appdkhi008\ClearCase\scripts\obsolete_streams.pl \PDS_PVOB";
        private static EnvironmentVariable[] environment = null;
        private static bool merge = false;
        private static int to_hour = 0;
        private static int to_min = 5;
        private static int to_sec = 0;

        private int id;
        private string user;
        private string[] userall;

        protected void Page_Load(object sender, EventArgs e)
        {
            HeaderPlaceHolder.Controls.Add(Page.LoadControl("Header.ascx"));

            InitUser();

            if (proxy == null)
            {
                proxy = new TrojaWS();
            }

            if (Session[CMDID] == null)
            {
                try
                {
                    id = proxy.CreateCommand(userall, command, arguments, environment, merge, to_hour, to_min, to_sec);
                    Session[CMDID] = id;
                }
                catch (Exception ex)
                {
                    StdErrLabel.Text = ex.Message;
                }
            }
            else
            {
                id = (int)Session[CMDID];
            }
        }

        protected void TimerTick(object Sender, EventArgs e)
        {
            Snapshot snapshot = proxy.TakeSnapshot(user, id);

            StdOutLabel.Text = snapshot.StandardOutput.Replace("\n", "<br />");
            StdErrLabel.Text = snapshot.StandardError;

            if (snapshot.HasExited)
            {
                ExitValue.Text = "Exitcode: " + snapshot.ExitCode;
                Timer.Enabled = false;
            }
        }

        protected void ButtonClick(object Sender, EventArgs e)
        {
            Button.Enabled = false;

            proxy.StartAsync(user, id);
            Timer.Enabled = true;
        }

        private void InitUser()
        {
            user = WindowsIdentity.GetCurrent().Name.ToLower();

            IdentityReferenceCollection groups = WindowsIdentity.GetCurrent().Groups;
            userall = new string[1 + groups.Count];

            userall[0] = user;

            int i = 1;
            foreach (IdentityReference reference in groups)
            {
                userall[i] = ((NTAccount)reference.Translate(typeof(NTAccount))).Value.ToLower();
                i++;
            }
        }
    }
}
