﻿using System;
using System.Diagnostics;

namespace net.praqma.systemlog
{
    public class SystemLog
    {
        public static string source = "Troja WS";
        public static string log = "Application";

        public static void WriteError(string user, Exception ex)
        {
            StackFrame frame = StackFrame();
            string details =
                string.Format("\nFile: {0}\nLineNo; {1}\nMethod: {2}\nUser: {3}\nException: {4}\nMessage:\n{5}\nStackTrace:\n{6}",
                frame.GetFileName(), frame.GetFileLineNumber(), frame.GetMethod(), user, ex.GetType().Name, ex.Message, ex.StackTrace);

            try
            {
                if (!EventLog.SourceExists(source))
                    EventLog.CreateEventSource(source, log);

                EventLog.WriteEntry(source, details, EventLogEntryType.Error);
            }
            catch
            {
                Debug.Print("WARNING: Could not create EventLog item.");
            }
            finally
            {
                Debug.Print("ERROR: {0}", details);
            }
        }

        public static void WriteWarning(string user, Exception ex)
        {
            StackFrame frame = StackFrame();
            string details =
                string.Format("\nFile: {0}\nLineNo; {1}\nMethod: {2}\nUser: {3}\nException: {4}\nMessage:\n{5}\nStackTrace:\n{6}",
                frame.GetFileName(), frame.GetFileLineNumber(), frame.GetMethod(), user, ex.GetType().Name, ex.Message, ex.StackTrace);

            try
            {
                if (!EventLog.SourceExists(source))
                    EventLog.CreateEventSource(source, log);

                EventLog.WriteEntry(source, details, EventLogEntryType.Warning);
            }
            catch
            {
                Debug.Print("WARNING: Could not create EventLog item.");
            }
            finally
            {
                Debug.Print("WARNING: {0}", details);
            }
        }

        public static void WriteInfo(string user, string info)
        {
            StackFrame frame = StackFrame();
            string details = string.Format("\nFile: {0}\nLineNo; {1}\nMethod: {2}\nUser: {3}\nInformation:\n{4}",
                frame.GetFileName(), frame.GetFileLineNumber(), frame.GetMethod(), user, info);

            try
            {
                if (!EventLog.SourceExists(source))
                    EventLog.CreateEventSource(source, log);

                EventLog.WriteEntry(source, details, EventLogEntryType.Information);
            }
            catch
            {
                Debug.Print("WARNING: Could not create EventLog item.");
            }
            finally
            {
                Debug.Print("INFOMATION: {0}", details);
            }
        }

        private static StackFrame StackFrame()
        {
            return new StackTrace(0, true).GetFrame(0);
        }
    }
}
