﻿using System;
using System.Configuration;
using System.Drawing;
using praqma.troja.webgui.usercontrols.menu;

namespace praqma.troja.webgui
{
    public partial class Troja : System.Web.UI.MasterPage
    {
        private static readonly Color DEFAULTCOLOR = ColorTranslator.FromHtml(ConfigurationSettings.AppSettings["default_color"]);

        protected void Page_Load(object sender, EventArgs e)
        {
            Views.Enabled = false;
            Views.ForeColor = Color.Gray;
        }

        protected void Elements_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/elements/");
        }

        protected void Types_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/types/");
        }

        protected void Views_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/views/");
        }

        protected void Log_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/log/");
        }

        public void SetMenu(string mainMenu, string subMenu)
        {
            clearMainMenu();
            SubmenuPlaceHolder.Controls.Clear();


            MenuUserControl sub = null;
            switch (mainMenu)
            {
                case "elements":
                    Elements.Font.Underline = true;
                    sub = LoadControl("~/usercontrols/menu/ElementMenu.ascx") as MenuUserControl;
                    sub.SetSubMenu(subMenu);
                    SubmenuPlaceHolder.Controls.Add(sub);
                    break;
                case "types":
                    Types.Font.Underline = true;
                    sub = LoadControl("~/usercontrols/menu/TypeMenu.ascx") as MenuUserControl;
                    sub.SetSubMenu(subMenu);
                    SubmenuPlaceHolder.Controls.Add(sub);
                    break;
                //case "views":
                //    Views.Font.Underline = true;
                //    sub = LoadControl("~/usercontrols/menu/ViewMenu.ascx") as MenuUserControl;
                //    sub.SetSubMenu(subMenu);
                //    SubmenuPlaceHolder.Controls.Add(sub);
                //    break;
                case "log":
                    Log.Font.Underline = true;
                    break;
            }
        }

        private void clearMainMenu()
        {
            Elements.Font.Underline = false;
            Types.Font.Underline = false;
            Views.Font.Underline = false;
            Log.Font.Underline = false;
        }

        public void SetStatus(string text, bool ok)
        {
            OutputLabel.Text = text;

            if (ok)
            {
                OutputLabel.ForeColor = DEFAULTCOLOR;
                StatusLabel.Text = "OK";
                StatusLabel.ForeColor = Color.Green;
            }
            else
            {
                OutputLabel.ForeColor = Color.Red;
                StatusLabel.Text = "ERROR";
                StatusLabel.ForeColor = Color.Red;
            }
        }
    }
}
