﻿using System;
using net.praqma.systemlog;

namespace praqma.troja.webgui.elemnts
{
    public partial class RemoveVersion : TrojaPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Master.SetMenu("elements", "removeversion");
        }

        protected void GoButton_Click(object sender, EventArgs e)
        {
            try
            {
                string ver = ArgumentInput.Text;

                if (!ValidateVersion(ver))
                {
                    Master.SetStatus(string.Format("Invalid input {0}", ver), false);
                    return;
                }

                string queryArguments = string.Format("{0} -query -object {1}", Configuration.Removetype, ver);
                string stdout = SyncCommand(Configuration.TrojaMaster, queryArguments);

                string host = Grep(stdout, "ReplicaHost=").Split('=')[1].Trim();
                string arguments = string.Format("{0} -remove -object {1} -by_user {2}", Configuration.LockType, ver, WhoAmI);
                stdout = SyncCommand(host, arguments, new TimeSpan(0, 1, 0), "removeversion -remove");

                Master.SetStatus(HtmlEncode(stdout), true);
                GuiLog.INSTANCE.Add(new LogItem(Guid.Empty, host, ServiceUser(host), "N/A", this.GetType().Name, ver));
            }
            catch (Exception ex)
            {
                SystemLog.WriteError(WhoAmI, ex);
                Master.SetStatus(HtmlEncode(ex.Message), false);
            }
        }
    }
}
