﻿using System;

namespace praqma.troja.webgui.elemnts
{
    public partial class RemoveVersion : TrojaPage
    {
        protected void GoButton_Click(object sender, EventArgs e)
        {
            try
            {
                string ver = ArgumentInput.Text;

                if (!ValidateVersion(ver))
                {
                    Master.SetStatus(string.Format("Invalid input {0}", ver), false);
                    return;
                }

                string queryArguments = string.Format("{0} -query -object {1}", REMOVEVERSION, ver);

                Guid queryId = TrojaMaster.CreateCommand(PERL, queryArguments, null, false, 0, 1, 0, "removeversion -query");
                string queryXml = TrojaMaster.StartSync(queryId);

                if (ExitCode(queryXml) != 0)
                {
                    Master.SetStatus(HtmlEncode(ErrorOut(queryXml)), false);
                    return;
                }

                string host = Grep(StandardOut(queryXml), "ReplicaHost=").Split('=')[1].Trim();
                string arguments = string.Format("{0} -remove -object {1} -by_user {2}", LOCKTYPE, ver, User.Identity.Name);

                Guid id = base[host].CreateCommand(PERL, arguments, null, false, 0, 1, 0, "removeversion -remove");
                string xml = base[host].StartSync(id);

                if (ExitCode(xml) == 0)
                    Master.SetStatus(HtmlEncode(StandardOut(xml)), true);
                else
                    Master.SetStatus(HtmlEncode(ErrorOut(xml)), false);
            }
            catch (Exception ex)
            {
                Master.SetStatus(HtmlEncode(ex.Message), false);
            }
        }
    }
}
