﻿using System;
using System.Configuration;
using net.praqma.systemlog;

namespace praqma.troja.webgui.types
{
    public partial class LockType : TrojaPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Master.SetMenu("types", "locktype");
        }

        protected void GoButton_Click(object sender, EventArgs e)
        {
            try
            {
                string obj = ArgumentInput.Text;

                string queryArguments = string.Format("{0} -query -object {1}", Configuration.LockType, obj);
                string stdout = SyncCommand(Configuration.TrojaMaster, queryArguments);

                string host = Grep(stdout, "ReplicaHost=").Split('=')[1].Trim();
                //TODO User
                string arguments = string.Format("{0} -lock -object {1} -by_user {2}", Configuration.LockType, obj, WhoAmI);
                stdout = SyncCommand(host, arguments, new TimeSpan(0, 1, 0), "locktype -lock");

                Master.SetStatus(HtmlEncode(stdout), true);
                GuiLog.INSTANCE.Add(new LogItem(Guid.Empty, host, ServiceUser(host), "N/A", this.GetType().Name, obj));
            }
            catch (Exception ex)
            {
                SystemLog.WriteError(WhoAmI, ex);
                Master.SetStatus(HtmlEncode(ex.Message), false);
            }
        }
    }
}
