﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using net.praqma.systemlog;

namespace praqma.troja.webgui.types
{
    public partial class RemoveType : TrojaPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Master.SetMenu("types", "removetype");
        }

        protected void GoButton_Click(object sender, EventArgs e)
        {
            try
            {
                string obj = ArgumentInput.Text;

                if (!ValidateType(obj))
                {
                    Master.SetStatus("Invalid input", false);
                    return;
                }

                string queryArguments = string.Format("{0} -query -object {1}", Configuration.LockType, obj);
                string stdout = SyncCommand(Configuration.TrojaMaster, queryArguments);

                string host = Grep(stdout, "ReplicaHost=").Split('=')[1].Trim();
                string arguments = string.Format("{0} -remove -object {1} -by_user {2} -max_age {3}", Configuration.LockType, obj, WhoAmI, Configuration.RemoveTypeMaxAge);
                stdout = SyncCommand(host, arguments, new TimeSpan(0, 1, 0), "removetype -remove");

                Master.SetStatus(HtmlEncode(stdout), true);
                GuiLog.INSTANCE.Add(new LogItem(Guid.Empty, host, ServiceUser(host), "N/A", this.GetType().Name, obj));
            }
            catch (Exception ex)
            {
                SystemLog.WriteError(WhoAmI, ex);
                Master.SetStatus(HtmlEncode(ex.Message), false);
            }
        }
    }
}
