﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using net.praqma.systemlog;

namespace praqma.troja.webgui.views
{
    public partial class Purge : ViewPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Master.SetMenu("views", "purge");
            resetDropDown();
        }

        protected void GoButton_Click(object sender, EventArgs e)
        {
            string storageLocation = StorageDropDownList.SelectedValue;

            if (storageLocation == null)
            {
                Master.SetStatus("Invalid storage location.", false);
                return;
            }

            try
            {
                string arguments = string.Format("{0} -purge {1}", Configuration.ViewQ, storageLocation);
                string stdout = SyncCommand(Configuration.TrojaMaster, arguments);
                Master.SetStatus(HtmlEncode(stdout), true);
            }
            catch (Exception ex)
            {
                SystemLog.WriteError(WhoAmI, ex);
                Master.SetStatus(HtmlEncode(ex.Message), false);
            }
        }

        protected void FindButton_Click(object sender, EventArgs e)
        {
            try
            {
                StorageDropDownList.Items.Clear();

                foreach (string storageLocation in base.LsQuarentine(ArgumentInput.Text))
                {
                    StorageDropDownList.Items.Add(new ListItem(storageLocation, storageLocation));
                }
            }
            catch (Exception ex)
            {
                SystemLog.WriteError(WhoAmI, ex);
                Master.SetStatus(ex.Message, false);
            }
        }

        private void resetDropDown()
        {
            StorageDropDownList.Items.Clear();
            StorageDropDownList.Items.Add(new ListItem("", null));
        }
    }
}
