﻿using System;
using System.Collections.Generic;
using System.Web;

namespace praqma.troja.webgui.views
{
    public class ViewPage : TrojaPage
    {
        protected string[] LsQuarentine(string since)
        {
            if (!ValidateSince(since))
            {
                throw new ArgumentException(string.Format("Invalid input: {0}", since));
            }

            string arguments = (since.Length > 0)
                ? string.Format("{0} -lsquarantine", Configuration.ViewQ)
                : string.Format("{0} -lsquarantine -since {1}", Configuration.ViewQ, since);

            string stdout = SyncCommand(Configuration.TrojaMaster, arguments, new TimeSpan(0, 1, 0), "lsquarantine");
            return Grep(stdout, "[a-z]:\\.*").Split('\n');
        }

        public bool ValidateSince(string since)
        {
            DateTime date;
            int days;

            return (since.Length == 0) || int.TryParse(since, out days) || DateTime.TryParse(since, out date);
        }
    }
}
